   --      
   --   graph
   -- graph -      
   ----------------------------------------------------------
   import LibGrp_2
   -----------------------------------
   connLists graph = connLsts graph []
   -------------------------------------------
   connLsts graph lists 
                | null graph = lists 
                | not (lMember (fst (head graph)) lists) 
                             = connLsts (tail graph)
                                  ((depthFirst graph 
                                        (fst (head graph))): lists)
                | True       = connLsts (tail graph) lists
   -------------------------------------------------------
   --  ,    vertex 
   -- -  ,  lists
   --------------------------------------------
   lMember vertex lists 
                | null lists               = False
                | elem vertex (head lists) = True
                | True  =  lMember vertex (tail lists)
   ------------------------------------------------------
   --        
   --   ;
   -- graph -      ,
   -- root -  ,    
   ---------------------------------------------------
   depthFirst graph root 
                  | null graph = []
                  | True       = defi graph [root] [root]
   ------------------------------------------------------
   -- visited -    ;
   -- path -  ,   
   ----------------------------------------------------
   defi graph visited path 
                  | null path = reverse visited
                  | null (expnd graph visited (head path)) 
                              = defi graph visited (tail path)
                  | True = defi graph
                                (expnd graph visited (head path)
                                                     ++ visited)
                                (expnd graph visited (head path)
                                                        ++ path)
   -------------------------------------------------------------
   --  ,    ,
   --    vertex
   -----------------------------
   expnd graph visited vertex 
                  | null (neighb2 vertex graph) = []
                  | True = firstNotVisited visited
                                           (neighb2 vertex graph)
   --------------------------------------------------------------
   firstNotVisited visited vlist 
                  | null vlist = []
                  | not (elem (head vlist) visited) 
                               = [(head vlist)]
                  | True       = firstNotVisited visited
                                                     (tail vlist)
   -- ***********************************************************
   -- ,   , 
   --    
   ----------------------------
   f2 graph lst | null lst = []
                | True     = (f1 graph (head lst)):
                                              (f2 graph (tail lst))
   ----------------------------------------------------------------
   f1 graph lst | null graph = []
                | elem (fst (head graph)) lst 
                             = (head graph):(f1 (tail graph) lst)
                | True       = f1 (tail graph) lst
   -----------------------------------------------
   --   :
   ---------------------------------------------
   test =   connLists [(1,[2,3]),(2,[3]),(5,[])] 
                                               == [[5],[1,2,3]]
         && connLists [(1,[2,3]),(2,[3]),(5,[]),(6,[])] 
                                               == [[6],[5],[1,2,3]]
         && connLists [(1,[2,3]),(2,[3]),(5,[6])] 
                                               == [[5,6],[1,2,3]]
         && connLists [(1,[2,3,5]),(2,[3]),(5,[6])] 
                                               == [[1,2,3,5,6]]
         ------------------------------------------------------
         && f2 [(1,[2,3]),(4,[5,6]),(5,[4]),(3,[2,1])] 
                                            [[1,2,3],[4,5,6]] ==
                     [[(1,[2,3]),(3,[2,1])],[(4,[5,6]),(5,[4])]]